/* Copyright (C) 2005-2006 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.11 $
 * $Date: 2006/10/29 00:52:57 $
 * $Author: sgop $
 */

#ifndef _UI_H_
#define _UI_H_

#include "download.h"
#include "library.h"
#include "chat.h"
#include "buddy.h"
#include "browse.h"
#include "search.h"
#include "upload.h"
#include "win32_defs.h"

G_BEGIN_DECLS

/** \defgroup UserInterface Gtk2 user interface */
/*@{*/

typedef struct
{
    void (*enter_main_loop)(void);
    void (*leave_main_loop)(void);
    
    void (*download_show_details)(download_t*);
    
    void (*file_tree_update_label)(file_tree_t*, const char*);
    void (*file_tree_set_progress)(file_tree_t*, double);
    void (*file_tree_set_progress_name)(file_tree_t*, const char*);
    void (*file_tree_set_abort)(file_tree_t*, GFunc, void*);
    
    void (*lib_working)(gboolean);
    
    void (*chat_switch_page)(chat_page_t*);
    gboolean (*chat_page_printable)(chat_page_t*);
    void (*chat_create_simple_page)(chat_page_t*);
    void (*chat_print)(chat_page_t*, int index, va_list);
    
    void (*threads_show)(const char* message);
#ifdef OWN_SOCKET_TRHEAD
    void (*thread_enter)();
    void (*thread_leave)();
#endif    
} ui_interface_t;

void UI_enter_main_loop(void);
void UI_leave_main_loop(void);
void UI_download_show_details(download_t*);
void UI_file_tree_update_label(file_tree_t*, const char*);
void UI_file_tree_set_progress(file_tree_t*, double);
void UI_file_tree_set_progress_name(file_tree_t*, const char*);
void UI_file_tree_set_abort(file_tree_t*, GFunc, void*);
void UI_lib_working(gboolean);
void UI_chat_switch_page(chat_page_t*);
gboolean UI_chat_page_printable(chat_page_t*);
void UI_chat_create_simple_page(chat_page_t*);
void UI_chat_print(chat_page_t*, int index, va_list);
void UI_threads_show(const char* message);
#ifdef OWN_SOCKET_TRHEAD
void UI_thread_enter();
void UI_thread_leave();
#endif
module_t* ui_module_instance();

const char* ui_get_name();
void ui_set_name(const char* ui);


/*@}*/

G_END_DECLS
#endif
