/* Copyright (C) 2005 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.4 $
 * $Date: 2006/07/22 17:11:48 $
 * $Author: sid4u $
 */

#ifndef _XML_HANDLER_H_
#define _XML_HANDLER_H_

#include <libxml/parser.h>

#include "module.h"

G_BEGIN_DECLS

/** \defgroup XmlModule Xml file access
 * @ingroup LopsterLibs
 */
/*@{*/

/** Function to save and load xml nodes.
 * @param xfile the xml document
 * @param node the xml node
 */
typedef void (*XmlNodeFunc)(xmlDocPtr xfile, xmlNodePtr node);


module_t* xml_module_instance();

void lopster_xml_register(const char* name, const char* filename, const char* root,
                          XmlNodeFunc load, XmlNodeFunc save);
void lopster_xml_register_home(const char* name, const char* filename, const char* root,
                               XmlNodeFunc load, XmlNodeFunc save);
gboolean    lopster_xml_change(const char* name, const char* filename, gboolean save);
gboolean    lopster_xml_load  (const char* name);
void        lopster_xml_save  (const char* name, unsigned timeout);
gboolean    lopster_xml_loaded(const char* name);
const char* lopster_xml_find  (const char* name);

/*@}*/

G_END_DECLS
#endif
